////////////////////////////////////////////////////////////
// Gadget IMS RADIO PLAYER V3 - Vista Widget Engine
// gadget.js      
// 2007 InfoMed Solutions (www.infomedsolutions.com)
////////////////////////////////////////////////////////////

var stationNames;
var stationURLs;
var currentStation;
var radiosXML;


// Increase the volume
function incVolume() {
	//Get the current volume and increase if below 100	
	var iVolume = mediaPlayer.settings.volume;
	if (iVolume < 100)
		{
		mediaPlayer.settings.volume = iVolume + 5;
		}
}

// Decrease the volume
function decVolume() {
	//Get the current volume and decrease if above zero
	var iVolume = mediaPlayer.settings.volume;
	if (iVolume > 0)
		{
		mediaPlayer.settings.volume = iVolume - 5;
		}
}


function loadCurrentStation()
{
	var tempName = System.Gadget.Settings.read("stationName");
	var currentURL = "";
	if (tempName != "")
	{
		currentURL = getURLByStationName(tempName);
	}
	if (currentURL == "") // station par dfaut si pas choisie
	{
		currentStation = stationNames[0];
		currentURL = stationURLs[0];
	}
	else
	{
		currentStation = tempName;
	}
	setMediaPlayer(currentURL);
}

function getURLByStationName(stationName)
{
	for (i=0;i<stationNames.length;i++)
	{
		if (stationNames[i] == stationName)
		return stationURLs[i];
	}
	return "";
}

function setMediaPlayer(stationURL)
{
	mediaPlayer.url = stationURL;
	updateNowPlaying();
}

function initStationList()
{

	var fso = new ActiveXObject("Scripting.FileSystemObject");
	var variableName = "userprofile";
	
	if (fso.FileExists(System.Environment.getEnvironmentVariable(variableName) + "\\ims_radios.xml")==false) {
		var xmlDocTemp = new ActiveXObject("Microsoft.XMLDOM");
		xmlDocTemp.async=false;
		xmlDocTemp.load("ims_radios.xml");
		xmlDocTemp.save(System.Environment.getEnvironmentVariable(variableName) + "\\ims_radios.xml");
	}
	
	var xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
	xmlDoc.async=false;
	xmlDoc.load(System.Environment.getEnvironmentVariable(variableName) + "\\ims_radios.xml");
	var radiosXML=xmlDoc.documentElement;
    
	stationNames = new Array();
	stationURLs = new Array();
	stationIMGs = new Array();
	
	stationCount = radiosXML.getAttribute("stationCount");
	
	for (var k=0 ; k<stationCount ; k++)
		{
			stationNames[k] = radiosXML.childNodes(k).getAttribute("station") ;
			stationURLs[k]  = radiosXML.childNodes(k).getAttribute("url") ;
			stationIMGs[k] = radiosXML.childNodes(k).getAttribute("img") ;
		}
		
	updateStationSetting();
}

function updateStationSetting()
{
	var stationCount = stationNames.length;
	System.Gadget.Settings.write("stationCount", stationCount);
	for (i=0;i<stationCount;i++)
	{
		System.Gadget.Settings.writeString("station"+i.toString(), stationNames[i]);
		System.Gadget.Settings.writeString("url"+i.toString(), stationURLs[i]);
		System.Gadget.Settings.writeString("img"+i.toString(), stationIMGs[i]);
	}
}

function deleteStationList()
{
	var deleteList = "http://www.infomedsolutions.com/gadget_radioplayer/delete.xml";
	
	var xmlDoc1 = new ActiveXObject("Microsoft.XMLDOM");
	xmlDoc1.async=false;
	xmlDoc1.load(deleteList);
	var deleteXML=xmlDoc1.documentElement;
	var deleteCount = deleteXML.getAttribute("stationCount");
	var delArray = new Array();
	
	var xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
	xmlDoc.async=false;
	var variableName = "userprofile";
	xmlDoc.load(System.Environment.getEnvironmentVariable(variableName) + "\\ims_radios.xml");
	radiosXML=xmlDoc.documentElement;
	
	stationCount = radiosXML.getAttribute("stationCount");
	
	for (i=0;i<stationCount;i++)
	{
		for (j=0;j<deleteCount;j++) {
			if ( radiosXML.childNodes(i).getAttribute("station") == deleteXML.childNodes(j).getAttribute("station")  && radiosXML.childNodes(i).getAttribute("url") == deleteXML.childNodes(j).getAttribute("url")) {
				delArray.push(i);
			}
		}
	}
	
	deleteCount = delArray.length;
	if ( deleteCount > 0 ) {
		for (i=0;i<deleteCount;i++)
		{
			toDel=delArray[i];
			stationCount--;
			var x=xmlDoc.getElementsByTagName("param");
			x.item(0).setAttribute("stationCount",stationCount);
			var y=xmlDoc.getElementsByTagName("radio")[toDel];
			x[0].removeChild(y);
		}
		xmlDoc.save(System.Environment.getEnvironmentVariable(variableName) + "\\ims_radios.xml");
		initStationList();
	}
}

function updateStationList()
{
	var updateList = "http://www.infomedsolutions.com/gadget_radioplayer/update.xml";
	var swapList = "swap.xml";
	var variableName = "userprofile";
	var addArray = new Array();
	
	var fso = new ActiveXObject("Scripting.FileSystemObject");
	
	if (fso.FileExists(System.Environment.getEnvironmentVariable(variableName) + "\\swap.xml")==false) {
		var xmlDocTemp = new ActiveXObject("Microsoft.XMLDOM");
		xmlDocTemp.async=false;
		xmlDocTemp.load("swap.xml");
		xmlDocTemp.save(System.Environment.getEnvironmentVariable(variableName) + "\\swap.xml");
	}
	
	var xmlDoc1 = new ActiveXObject("Microsoft.XMLDOM");
	xmlDoc1.async=false;
	xmlDoc1.load(updateList);
	var updateXML = xmlDoc1.documentElement;
	var updateCount = updateXML.getAttribute("stationCount");
	
	var xmlDoc2 = new ActiveXObject("Microsoft.XMLDOM");
	xmlDoc2.async=false;
	xmlDoc2.load(System.Environment.getEnvironmentVariable(variableName) + "\\swap.xml");
	var swapXML = xmlDoc2.documentElement;
	var swapCount = swapXML.getAttribute("stationCount");
	
	var xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
	xmlDoc.async=false;
	xmlDoc.load(System.Environment.getEnvironmentVariable(variableName) + "\\ims_radios.xml");
	radiosXML=xmlDoc.documentElement;
	stationCount = radiosXML.getAttribute("stationCount");
	
	if ( updateCount > 0 ) {
		for (i=0;i<updateCount;i++)
		{
			var z=0;
			var stationName = updateXML.childNodes(i).getAttribute("station");
			var stationUrl  = updateXML.childNodes(i).getAttribute("url");
			var stationImg  = updateXML.childNodes(i).getAttribute("img");
			var stationPos  = updateXML.childNodes(i).getAttribute("pos");
			
			if ( swapCount > 0 ) {
				for (j=0;j<swapCount;j++) {
					if ( stationName == swapXML.childNodes(j).getAttribute("station")  && stationUrl == swapXML.childNodes(j).getAttribute("url")  && stationImg == swapXML.childNodes(j).getAttribute("img") ) {
						z++;
					}
				}
			}
			for (j=0;j<stationCount;j++) {
				if ( stationName == radiosXML.childNodes(j).getAttribute("station")  && stationUrl == radiosXML.childNodes(j).getAttribute("url")  && stationImg == radiosXML.childNodes(j).getAttribute("img") ) {
					z++;
				}
			}
			
			if ( z == 0 ) {
				addArray.push(i);
			}
		}
	}
	
	updateCount = addArray.length;
	if ( updateCount > 0 ) {
		for (i=0;i<updateCount;i++)
		{
			var z = addArray[i];
			var stationName = updateXML.childNodes(z).getAttribute("station");
			var stationUrl  = updateXML.childNodes(z).getAttribute("url");
			var stationImg  = updateXML.childNodes(z).getAttribute("img");
			var stationPos  = updateXML.childNodes(z).getAttribute("pos");
			
			if ( stationPos == "first" ) {
				stationCount++;
				swapCount++;
				var x=xmlDoc.getElementsByTagName("param");
				x.item(0).setAttribute("stationCount",stationCount);
				// Cre une nouvelle radio
				var newel=xmlDoc.createElement('radio');
				var newtext=xmlDoc.createTextNode(stationName);
				newel.appendChild(newtext);
				var root = xmlDoc.documentElement;
				root.insertBefore(newel, root.childNodes.item(0)); 
				
				// Marque les attributs
				var y=xmlDoc.getElementsByTagName("radio");
				y.item(0).setAttribute("station",stationName);
				y.item(0).setAttribute("url",stationUrl);
				y.item(0).setAttribute("img",stationImg);
			
				xmlDoc.save(System.Environment.getEnvironmentVariable(variableName) + "\\ims_radios.xml");
				
				var x=xmlDoc2.getElementsByTagName("param");
				x.item(0).setAttribute("stationCount",swapCount);
				var newel=xmlDoc2.createElement('radio');
				var newtext=xmlDoc2.createTextNode(stationName);
				newel.appendChild(newtext);
				x[0].appendChild(newel);
				
				// Marque les attributs
				var y=xmlDoc2.getElementsByTagName("radio");
				y.item(swapCount-1).setAttribute("station",stationName);
				y.item(swapCount-1).setAttribute("url",stationUrl);
				y.item(swapCount-1).setAttribute("img",stationImg);
			
				xmlDoc2.save(System.Environment.getEnvironmentVariable(variableName) + "\\swap.xml");
			} else {
				stationCount++;
				swapCount++;
				var x=xmlDoc.getElementsByTagName("param");
				x.item(0).setAttribute("stationCount",stationCount);
				// Cre une nouvelle radio
				var newel=xmlDoc.createElement('radio');
				var newtext=xmlDoc.createTextNode(stationName);
				newel.appendChild(newtext);
				x[0].appendChild(newel);
				
				// Marque les attributs
				var y=xmlDoc.getElementsByTagName("radio");
				y.item(stationCount-1).setAttribute("station",stationName);
				y.item(stationCount-1).setAttribute("url",stationUrl);
				y.item(stationCount-1).setAttribute("img",stationImg);
			
				xmlDoc.save(System.Environment.getEnvironmentVariable(variableName) + "\\ims_radios.xml");
				
				var x=xmlDoc2.getElementsByTagName("param");
				x.item(0).setAttribute("stationCount",swapCount);
				var newel=xmlDoc2.createElement('radio');
				var newtext=xmlDoc2.createTextNode(stationName);
				newel.appendChild(newtext);
				x[0].appendChild(newel);
				
				// Marque les attributs
				var y=xmlDoc2.getElementsByTagName("radio");
				y.item(swapCount-1).setAttribute("station",stationName);
				y.item(swapCount-1).setAttribute("url",stationUrl);
				y.item(swapCount-1).setAttribute("img",stationImg);
			
				xmlDoc2.save(System.Environment.getEnvironmentVariable(variableName) + "\\swap.xml");
			}
			
		}
	}
	initStationList();
}

function loadStationList()
{
	stationNames = new Array();
	stationURLs = new Array();
	stationIMGs = new Array();
	
	var stationCount = 0;
	stationCount = System.Gadget.Settings.read("stationCount");
	if (stationCount > 0)
	{
		for (i=0;i<stationCount;i++)
		{
			stationNames[i] = System.Gadget.Settings.readString("station"+i.toString());
			stationURLs[i]  = System.Gadget.Settings.readString("url"+i.toString());
			stationIMGs[i]  = System.Gadget.Settings.readString("img"+i.toString());
		}
	}
	else
	{
		initStationList();
	}
}

function loadStationListStartup()
{
	stationNames = new Array();
	stationURLs = new Array();
	stationIMGs = new Array();
	
	var stationCount = 0;
	stationCount = System.Gadget.Settings.read("stationCount");
	if (stationCount > 0)
	{
		for (i=0;i<stationCount;i++)
		{
			stationNames[i] = System.Gadget.Settings.readString("station"+i.toString());
			stationURLs[i]  = System.Gadget.Settings.readString("url"+i.toString());
			stationIMGs[i]  = System.Gadget.Settings.readString("img"+i.toString());
		}
	}
	else
	{
		initStationList();
	}
	deleteStationList();
	updateStationList();
}

function dockStateChange()
{
	with(document.body.style)
		width=130,
		height=67;
	with(playbackStatus.style)
		left=10,
		top=5,
		width=90;
	with(nowPlaying.style)
		left=10,
		top=30,
		width=70;
	with(browsePlaylist.style)
		left=75,
		top=26;
	with(playbackControls.style)
		left=100,
		top=4;
	with(updateRadio.style)
		left=100,
		top=26;
	with(downVol.style)
		left=80,
		top=44;	
	with(upVol.style)
		left=100,
		top=44;	
	controlImageMouse(false);
	updateImageMouse(false);
	playlistImageMouse(false);
	moinsImageMouse(false);
	plusImageMouse(false);	
}

function apresFlyout() 
{
	loadMain();
	mediaPlayer.controls.play();
}

function controlImageClick()
{		
	if (controlImage.src.indexOf("stop") > 0)
	{
		mediaPlayer.controls.stop();
	}
	else
	{
		mediaPlayer.controls.play();
	}
}

function browseImageClick()
{		
	loadMain();
	var nowPlayingText = "<div id='nowPlayingText'><font color='white'><b>Playlist locale</b></font></div>";
	nowPlaying.innerHTML = nowPlayingText;
	var fichier;
    fichier = playlisturl.click();
	mediaPlayer.url = playlisturl.value;

}

function controlImageMouse(isMouseOn)
{
	var isDocked = System.Gadget.docked;
	if (controlImage.src.indexOf("stop") > 0)
	{
		controlImage.src = "img/stop" + (isMouseOn?"_hover":"") + (isDocked?"_sm.png":".png");
	}
	else
	{
		controlImage.src = "img/play" + (isMouseOn?"_hover":"") + (isDocked?"_sm.png":".png");
	}
}

function playlistImageMouse(isMouseOn)
{
	var isDocked = System.Gadget.docked;
	browseImage.src = "img/browse" + (isMouseOn?"_hover":"") + (isDocked?"_sm.png":".png");
}

function updateImageMouse(isMouseOn)
{
	var isDocked = System.Gadget.docked;
	updateImage.src = "img/update" + (isMouseOn?"_hover":"") + (isDocked?"_sm.png":".png");
}

function moinsImageMouse(isMouseOn)
{
	var isDocked = System.Gadget.docked;
	moinsImage.src = "img/moins" + (isMouseOn?"_hover":"") + (isDocked?"_sm.png":".png");
}

function plusImageMouse(isMouseOn)
{
	var isDocked = System.Gadget.docked;
	plusImage.src = "img/plus" + (isMouseOn?"_hover":"") + (isDocked?"_sm.png":".png");
}

function updateNowPlaying()
{
	var nowPlayingText = "<div id='nowPlayingText'><font color='white'><b>" + currentStation + "</b></font></div>";
	nowPlaying.innerHTML = nowPlayingText;
}

function playStateChange(newstate)
{
	switch (newstate){ 
	case 1: // Stop
		playbackStatus.innerHTML = "Stop";
		controlImage.src = controlImage.src.replace(/stop/, "play");
		break;
	case 2: // Pause
		playbackStatus.innerHTML = "Pause";
		controlImage.src = controlImage.src.replace(/stop/, "play");
		break;
	case 3: // Lecture
		playbackStatus.innerHTML = "Lecture";
		controlImage.src = controlImage.src.replace(/play/, "stop");
		break;
	case 6: // Cache
		playbackStatus.innerHTML = "Mise en cache";
		break;
	case 7: // Attente
		playbackStatus.innerHTML = "Attente";
		break;
	case 8: // Fin
		playbackStatus.innerHTML = "Fin";
		controlImage.src = controlImage.src.replace(/stop/, "play");
		break;
	case 9: // Connexion
		playbackStatus.innerHTML = "Connexion";
		break;
	case 10: // Prt
		playbackStatus.innerHTML = "Pret";
		controlImage.src = controlImage.src.replace(/stop/, "play");
		break;
	}
}


function loadMain()
{	
	loadStationList();
	loadCurrentStation();
	dockStateChange(); // force le refresh au lancement de Sidebar.exe 

	System.Gadget.onDock = dockStateChange;
	System.Gadget.onUndock = dockStateChange;
    
	System.Gadget.settingsUI = "settings.html";
	System.Gadget.Flyout.file = "flyout.html";
	System.Gadget.Flyout.onHide = apresFlyout;
}
function loadMainStartup()
{	
	loadStationListStartup();
	loadCurrentStation();
	dockStateChange(); // force le refresh au lancement de Sidebar.exe 

	System.Gadget.onDock = dockStateChange;
	System.Gadget.onUndock = dockStateChange;
    
	System.Gadget.settingsUI = "settings.html";
	System.Gadget.Flyout.file = "flyout.html";
	System.Gadget.Flyout.onHide = apresFlyout;
}

var BackgroundTheme = "12";

function init() 
{
	System.Gadget.settingsUI = "Settings.html";
	System.Gadget.onSettingsClosed = settingsClosed;
			
	if (System.Gadget.Settings.read("BackgroundTheme")) 
		{
			BackgroundTheme = System.Gadget.Settings.read("BackgroundTheme");
		} 
	else 
	{
		System.Gadget.Settings.write("BackgroundTheme", BackgroundTheme);
	}

	System.Gadget.background = "images/bg" + BackgroundTheme + ".png";

	loadMainStartup();		
}
				
function settingsClosed()
{
    BackgroundTheme = System.Gadget.Settings.read("BackgroundTheme");
	System.Gadget.background = "images/bg" + BackgroundTheme + ".png";
}



